## zxing-cpp 2.3.0

=== debian/changelog ===
zxing-cpp (2.3.0-5) unstable; urgency=medium

  * debian/control: Bump Standards-Version to 4.7.3.
  * debian/tests/control: Manually write python-based autopkgtest
    instead of relying on autodep8 for autopkgtest generation since
    this package is only built against the default python3 version,
    not all supported python3 version.
  * debian/tests/autopkgtest-pkg-python.conf: Deleted accordingly.

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #1123686)
    + Multiarchify Python Build-Depends.
    + Export sysconfig data for cross compilation.

 -- Boyuan Yang <byang@debian.org>  Thu, 05 Feb 2026 12:36:05 -0500

zxing-cpp (2.3.0-4) unstable; urgency=medium

  * debian/patches/backport/: Cherry-pick upstream-suggested patches
    and prepare for Debian 13 release:
     - backport/3adaebc1a8a198d1e3b8eed169621a03d81cf387.patch
     - backport/82806f5f92173b8cb4e1e9bee13a2d07a33fb69f.patch
     - backport/93175e071d1719c44c0ad1193539141eb846999f.patch
     - backport/f3e36d0297d434a9c4b87035583760afda953360.patch
     - backport/ba3b61feb918a2371b2a991e759bde7c380b6a23.patch
     - backport/68c5727ba30bccf93056f8d19ba9cfc55994f2b5.patch
     - backport/36495ef0358c3d56d2e06e8a8ffdaac6afafcdb8.patch
     - backport/b46534d9bca0ce1832ee192c80e7395b999341b7.patch
     - backport/f45c1f0b4bf48c80fb7fb6ce42c7457eba379013.patch
     - 0010-Disable-test-unit-aztec-AZDecoderTest.cpp.patch:
       Needed to incorporate fuzzy patches.
    Note that test changes in some patches are dropped to handle
    fuzzy patches.
  * debian/rules: Drop definition of NDEBUG macro since the proper
    fix has been merged in the patches.

 -- Boyuan Yang <byang@debian.org>  Wed, 30 Apr 2025 14:07:19 -0400

zxing-cpp (2.3.0-3) unstable; urgency=medium

  * debian/rules: Define NDEBUG macro for now to circumvent upstream
    abuse of NDEBUG macro in 2.3.0 release. (Closes: #1095196)

 -- Boyuan Yang <byang@debian.org>  Fri, 07 Feb 2025 15:47:30 -0500

zxing-cpp (2.3.0-2) unstable; urgency=medium

  * debian/rules: Enable building C API as suggested upstream.

 -- Boyuan Yang <byang@debian.org>  Fri, 03 Jan 2025 19:51:36 -0500

zxing-cpp (2.3.0-1) unstable; urgency=medium

  * New upstream release 2.3.0.
  * debian/patches/: Drop all old patches, merged upstream.
  * debian/rules:
    + Update all CMake option names.
    + Add option to use system zint by default.
  * debian/copyright: Update Files-Excluded pattern and copyright info.

 -- Boyuan Yang <byang@debian.org>  Thu, 02 Jan 2025 09:54:35 -0500

=== debian/control ===
Source: zxing-cpp
Section: libs
Priority: optional
Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends:
 cmake (>= 3.16),
 debhelper-compat (= 13),
 dh-sequence-python3,
 libfmt-dev <!nocheck>,
 libgmock-dev <!nocheck>,
 libgtest-dev <!nocheck>,
 libpython3-dev,
 libstb-dev,
 pkgconf,
 pybind11-dev,
 python3-dev:native,
 python3-numpy <!nocheck>,
 python3-opencv <!nocheck>,
 python3-pil <!nocheck>,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://github.com/zxing-cpp/zxing-cpp
Vcs-Git: https://salsa.debian.org/debian/zxing-cpp.git
Vcs-Browser: https://salsa.debian.org/debian/zxing-cpp
Description: C++ port of ZXing library
 ZXing-C++ ("zebra crossing") is an open-source, multi-format 1D/2D
 barcode image processing library implemented in C++.
 .
 It was originally ported from the Java ZXing library but has been
 developed further and now includes many improvements in terms of
 quality and performance. It can both read and write barcodes in a
 number of formats:  QR Code, DataMatrix, Aztec, PDF417, UPC-A, UPC-E,
 EAN-8, EAN-13, DataBar/RSS, Code 39, Code 93, Code 128, Codabar, ITF.

Package: libzxing-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libzxing3 (= ${binary:Version}),
 ${misc:Depends},
Replaces:
 libzxingcore-dev (<< 1.3.0~),
Breaks:
 libzxingcore-dev (<< 1.3.0~),
Description: ${source:Synopsis} (development files)
 ${source:Extended-Description}
 .
 This package provides development files for zxing-cpp library.

Package: libzxing3
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (library files)
 ${source:Extended-Description}
 .
 This package provides library files for zxing-cpp library.

Package: python3-zxing-cpp
Architecture: any
Section: python
Depends:
 python3-numpy,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (python3 binding)
 ${source:Extended-Description}
 .
 This package provides python3 binding for zxing-cpp library.

Package: zxing-cpp-tools
Architecture: any
Section: utils
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Utilities provided by ZXing library
 ${source:Extended-Description}
 .
 This package provides various example utilities written with zxing-cpp
 library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1
#
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#
# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND =

# Workaround of https://github.com/zxing-cpp/zxing-cpp/issues/900
# See https://bugs.debian.org/1095196
# Should be removed once zxing-cpp (>= 2.3.1) is packaged
#export DEB_CXXFLAGS_MAINT_APPEND = -DNDEBUG
# no longer needed since patches/828.patch merged

# Try to export buildflags. No guarantee to be useful yet
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/buildflags.mk

# https://bugs.debian.org/1123686
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata__$(DEB_HOST_ARCH_OS)_$(DEB_HOST_MULTIARCH)
endif


%:
	dh $@ --with python3

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
TEST_FLAG := ON
else
TEST_FLAG := OFF
endif

# PYTHON_EXECUTABLE: force selection of default python version
#
# UNIT_TESTS: should only be used in debug builds, disable it
# following upstream recommendation.
#
# CMAKE_CXX_STANDARD: default to 20 (omitted).
#     WARNING: changing this flag will break ABI!
#
override_dh_auto_configure:
	dh_auto_configure -- \
	        -DZXING_BLACKBOX_TESTS=$(TEST_FLAG)  \
	        -DZXING_UNIT_TESTS=OFF               \
	        -DZXING_PYTHON_MODULE=ON             \
	        -DZXING_C_API=ON                     \
	        -DZXING_USE_BUNDLED_ZINT=ON          \
	        -DZXING_DEPENDENCIES=LOCAL           \
	        -DPYTHON_EXECUTABLE:FILEPATH=$(shell command -v $$(py3versions -d))

override_dh_auto_test:
	# Exclude tests that needs samples directory
	dh_auto_test -- \
	        ARGS\+=-E \
	        ARGS\+=ReaderTest\\\|ZXingCTest \
	        $(NULL)

=== debian/tests/control ===
# Manually specify autopkgtest instead of autodep8
# due to the package only supporting py3versions -d
# instead of py3versions -s or py3versions -r.
#
Test-Command: set -e ; for py in $(py3versions -d 2>/dev/null) ; do cd "$AUTOPKGTEST_TMP" ; echo "Testing with $py:" ; $py -c "import zxingcpp; print(zxingcpp)" ; done
Depends: python3, python3-zxing-cpp
Restrictions: allow-stderr, superficial
Features: test-name=autodep8-python3

## zxing-cpp 3.0.0~rc1+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(ZXing)

option (ZXING_READERS "Build with reader support (decoders)" ON)
set    (ZXING_WRITERS "ON" CACHE STRING "Build with old and/or new writer (encoder) backend (OFF/ON/OLD/NEW/BOTH)")
option (ZXING_C_API "Build the C-API" ON)
option (ZXING_EXPERIMENTAL_API "Build with experimental API" OFF)
option (ZXING_EXAMPLES "Build the example barcode reader/writer applications" ON)
option (ZXING_BLACKBOX_TESTS "Build the black box reader/writer tests" OFF)
option (ZXING_UNIT_TESTS "Build the unit tests (don't enable for production builds)" OFF)
option (ZXING_INSTALL_TEST "Test if the installed/public API works" OFF)
option (ZXING_PYTHON_MODULE "Build the python module" OFF)
set    (ZXING_DEPENDENCIES "AUTO" CACHE STRING "Fetch from github or use locally installed (AUTO/GITHUB/LOCAL)")
option (ZXING_CLANG_TIDY "Enable clang-tidy analysis" OFF)

if (WIN32)
    option (BUILD_SHARED_LIBS "Build and link as shared library" OFF)
else()
    option (BUILD_SHARED_LIBS "Build and link as shared library" ON)
endif()

if (MSVC)
    add_definitions (-DUNICODE -D_UNICODE -D_CRT_SECURE_NO_WARNINGS)
    option (ZXING_LINK_CPP_STATICALLY "MSVC only, link standard library statically (/MT and /MTd)" OFF)
    if (LINK_CPP_STATICALLY OR ZXING_LINK_CPP_STATICALLY)
        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
    endif()
endif()

if (NOT CMAKE_BUILD_TYPE)
    set (DEFAULT_BUILD_TYPE "Release")
    message (STATUS "Setting build type to '${DEFAULT_BUILD_TYPE}' as none was specified.")
    set (CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}" CACHE STRING "Choose the type of build." FORCE)
    set_property (CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

if (NOT (ZXING_READERS OR ZXING_WRITERS))
    message(FATAL_ERROR "At least one of ZXING_READERS/ZXING_WRITERS must be enabled.")
endif()

set(ZXING_WRITERS_LIST OFF ON OLD NEW BOTH)
set_property(CACHE ZXING_WRITERS PROPERTY STRINGS ${ZXING_WRITERS_LIST})
if(NOT ZXING_WRITERS IN_LIST ZXING_WRITERS_LIST)
    message(FATAL_ERROR "ZXING_WRITERS must be one of ${ZXING_WRITERS_LIST}")
endif()

set(ZXING_DEPENDENCIES_LIST AUTO GITHUB LOCAL)
set_property(CACHE ZXING_DEPENDENCIES PROPERTY STRINGS ${ZXING_DEPENDENCIES_LIST})
if(NOT ZXING_DEPENDENCIES IN_LIST ZXING_DEPENDENCIES_LIST)
    message(FATAL_ERROR "ZXING_DEPENDENCIES must be one of ${ZXING_DEPENDENCIES_LIST}")
endif()

if (NOT DEFINED CMAKE_CXX_STANDARD)
    set (CMAKE_CXX_STANDARD 20)
    set (CMAKE_CXX_STANDARD_REQUIRED ON)
    set (CMAKE_CXX_EXTENSIONS OFF)
endif()

set(CMAKE_COLOR_DIAGNOSTICS ON)

if (ZXING_CLANG_TIDY)
    find_program(CMAKE_CXX_CLANG_TIDY NAMES "clang-tidy" DOC "Path to clang-tidy executable")
    if (NOT CMAKE_CXX_CLANG_TIDY)
        message(WARNING "clang-tidy not found.")
    else()
        message(STATUS "clang-tidy found: ${CMAKE_CXX_CLANG_TIDY}")
        set(ZXING_DISABLE_PCH ON)
    endif()
endif()

# make installed binaries relocatable on macOS and Linux
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
if(APPLE)
    set(CMAKE_MACOSX_RPATH ON) # make the binar
    set(CMAKE_INSTALL_RPATH "@loader_path/../lib")
elseif(UNIX)
    set(CMAKE_INSTALL_RPATH "$ORIGIN/../lib")
endif()

add_subdirectory (core)

enable_testing()

include(zxing.cmake)

if (ZXING_EXAMPLES)
    add_subdirectory (example)
    add_subdirectory (wrappers/qt)
endif()
if (ZXING_BLACKBOX_TESTS)
    add_subdirectory (test/blackbox)
endif()
if (ZXING_UNIT_TESTS)
    add_subdirectory (test/unit)
endif()
if (ZXING_INSTALL_TEST)
    add_test(
        NAME InstallTest
        COMMAND
            ${CMAKE_COMMAND}
            -DPROJECT_BINARY_DIR=${CMAKE_BINARY_DIR}
            -DSOURCE_DIR=${CMAKE_SOURCE_DIR}/test/install
            -P ${CMAKE_SOURCE_DIR}/test/install/run.cmake
    )
endif()
if (ZXING_PYTHON_MODULE)
    add_subdirectory (wrappers/python)
endif()
if (ZXING_C_API)
    add_subdirectory (wrappers/c)
endif()

=== backend/CMakeLists.txt ===
# Copyright (C) 2008 by BogDan Vatra < bogdan@licentia.eu >
# Copyright (C) 2009-2025 Robin Stuart <rstuart114@gmail.com>
# vim: set ts=4 sw=4 et :

cmake_minimum_required(VERSION 3.10)
project(zint)

if(ZINT_USE_PNG)
    cmake_policy(SET CMP0074 NEW) # Allow use of `<PackageName>_ROOT` (Windows)
    find_package(PNG)
endif()
if(ZINT_USE_GS1SE)
    if(WIN32)
        find_library(GS1SE gs1encoders PATH ${GS1SE_PATH})
    else()
        find_library(GS1SE gs1encoders)
    endif()
endif()

set(zint_COMMON_SRCS common.c eci.c filemem.c general_field.c gs1.c large.c library.c reedsol.c)
set(zint_ONEDIM_SRCS 2of5.c 2of5inter.c 2of5inter_based.c bc412.c channel.c codabar.c code.c code11.c code128.c
                     code128_based.c dxfilmedge.c medical.c plessey.c rss.c telepen.c upcean.c)
set(zint_POSTAL_SRCS auspost.c imail.c mailmark.c postal.c)
set(zint_TWODIM_SRCS aztec.c codablock.c code1.c code16k.c code49.c composite.c dmatrix.c dotcode.c gridmtx.c
                     hanxin.c maxicode.c pdf417.c qr.c ultra.c)
set(zint_OUTPUT_SRCS bmp.c emf.c gif.c output.c pcx.c ps.c raster.c svg.c tif.c vector.c)
if(ZINT_USE_PNG AND PNG_FOUND)
    set(zint_OUTPUT_SRCS ${zint_OUTPUT_SRCS} png.c)
endif()
set(zint_SRCS ${zint_OUTPUT_SRCS} ${zint_COMMON_SRCS} ${zint_ONEDIM_SRCS} ${zint_POSTAL_SRCS} ${zint_TWODIM_SRCS})

if(ZINT_SHARED)
    add_library(zint SHARED ${zint_SRCS})

    if(WIN32)
        target_sources(${PROJECT_NAME} PRIVATE libzint.rc)
    endif()
endif()

if(ZINT_STATIC)
    add_library(zint-static STATIC ${zint_SRCS})
    if(WIN32)
        set_target_properties(zint-static PROPERTIES OUTPUT_NAME zint-static)
    else()
        set_target_properties(zint-static PROPERTIES OUTPUT_NAME zint)
    endif()
endif()

function(zint_target_link_libraries library)
    if(ZINT_SHARED)
        target_link_libraries(zint ${library})
    endif()
    if(ZINT_STATIC)
        target_link_libraries(zint-static ${library})
    endif()
endfunction()

function(zint_target_compile_definitions scope definition)
    if(ZINT_SHARED)
        target_compile_definitions(zint ${scope} ${definition})
    endif()
    if(ZINT_STATIC)
        target_compile_definitions(zint-static ${scope} ${definition})
    endif()
endfunction()

function(zint_target_compile_options scope option)
    if(ZINT_SHARED)
        target_compile_options(zint ${scope} ${option})
    endif()
    if(ZINT_STATIC)
        target_compile_options(zint-static ${scope} ${option})
    endif()
endfunction()

function(zint_target_include_directories)
    if(ZINT_SHARED)
        target_include_directories(zint ${ARGN})
    endif()
    if(ZINT_STATIC)
        target_include_directories(zint-static ${ARGN})
    endif()
endfunction()

if(ZINT_SHARED)
    set_target_properties(zint PROPERTIES   SOVERSION "${ZINT_VERSION_MAJOR}.${ZINT_VERSION_MINOR}"
                                            VERSION ${ZINT_VERSION})
endif()

if(ZINT_USE_PNG AND PNG_FOUND)
    zint_target_link_libraries(PNG::PNG)
    message(STATUS "Using PNG")
else()
    zint_target_compile_definitions(PRIVATE ZINT_NO_PNG)
    message(STATUS "Not using PNG")
endif()

if(ZINT_USE_GS1SE AND GS1SE)
    zint_target_link_libraries(${GS1SE})
    zint_target_compile_definitions(PRIVATE ZINT_HAVE_GS1SE)
    message(STATUS "Using GS1 Syntax Engine")
else()
    message(STATUS "Not using GS1 Syntax Engine")
endif()

# Incompatible with ZINT_SANITIZE (and also with ZINT_USE_PNG unless libpng instrumented)
if(NOT ZINT_SANITIZE AND ZINT_SANITIZEM AND CMAKE_C_COMPILER_ID MATCHES "Clang")
    add_compile_options(-fsanitize=memory -fsanitize-memory-track-origins -fno-omit-frame-pointer -O2)
    link_libraries(-fsanitize=memory)
    zint_target_compile_definitions(PRIVATE ZINT_SANITIZEM)
endif()

if(ZINT_TEST)
    zint_target_compile_definitions(PUBLIC ZINT_TEST)
endif()

check_c_compiler_flag("-Wc90-c99-compat" C_COMPILER_FLAG_WC90_C99_COMPAT)
if(C_COMPILER_FLAG_WC90_C99_COMPAT)
    zint_target_compile_options(PRIVATE "-Wc90-c99-compat")
endif()

if(NOT MSVC)
    # Link with standard C math library.
    zint_target_link_libraries(m)
endif()

if(MSVC)
    if(ZINT_SHARED)
        target_compile_definitions(zint PRIVATE DLL_EXPORT)
    endif()
endif()

zint_target_include_directories(PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)
if(WIN32 AND GS1SE)
    get_filename_component(GS1SE_INC ${GS1SE} DIRECTORY)
    zint_target_include_directories(PRIVATE ${GS1SE_INC})
endif()

# Adapted from old (2008) KDE "SetPaths.cmake" to use GNUInstallDirs
set(INSTALL_TARGETS_DEFAULT_ARGS RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
                                 LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
                                 ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}" COMPONENT Devel)

if(ZINT_SHARED)
    install(TARGETS zint EXPORT zint-targets ${INSTALL_TARGETS_DEFAULT_ARGS})
endif()
if(ZINT_STATIC)
    install(TARGETS zint-static EXPORT zint-targets ${INSTALL_TARGETS_DEFAULT_ARGS})
endif()
install(EXPORT zint-targets NAMESPACE zint:: DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zint")
install(FILES zint.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} COMPONENT Devel)

if(ZINT_TEST)
    add_subdirectory(tests)
endif()

=== core/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project (ZXing VERSION "3.0.0")
set (ZXING_VERSION_SUFFIX "-rc1")
set (ZXING_SONAME 4) # see https://github.com/zxing-cpp/zxing-cpp/issues/333

option (ZXING_USE_BUNDLED_ZINT "Use the bundled libzint for barcode creation/writing" ON)
foreach(format 1D AZTEC DATAMATRIX MAXICODE PDF417 QRCODE)
    option ("ZXING_ENABLE_${format}" "Enable support for ${format} barcodes" ON)
endforeach()

if (NOT DEFINED CMAKE_CXX_STANDARD)
    set (CMAKE_CXX_STANDARD 20)
    set (CMAKE_CXX_STANDARD_REQUIRED ON)
    set (CMAKE_CXX_EXTENSIONS OFF)
endif()

if (BUILD_SHARED_LIBS)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()

if (NOT DEFINED ZXING_WRITERS)
    set (ZXING_WRITERS OFF)
endif()

if (NOT DEFINED ZXING_READERS)
    set (ZXING_READERS ON)
endif()

set (ZXING_WRITERS_NEW OFF)
set (ZXING_WRITERS_OLD OFF)
if (ZXING_WRITERS MATCHES "OLD")
    set (ZXING_WRITERS ON)
    set (ZXING_WRITERS_OLD ON)
elseif (ZXING_WRITERS MATCHES "NEW|ON")
    set (ZXING_WRITERS ON)
    set (ZXING_WRITERS_NEW ON)
elseif (ZXING_WRITERS MATCHES "BOTH")
    set (ZXING_WRITERS ON)
    set (ZXING_WRITERS_NEW ON)
    set (ZXING_WRITERS_OLD ON)
endif()

if (BUILD_SHARED_LIBS)
    set (CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

set (ZXING_USE_ZINT ${ZXING_WRITERS_NEW}) # see Version.h.in

set (ZXING_PUBLIC_FLAGS
    $<$<CXX_COMPILER_ID:MSVC>:/Zc:__cplusplus>
)

set (ZXING_PRIVATE_FLAGS
    -DZXING_INTERNAL
    $<$<BOOL:${ZXING_UNIT_TESTS}>:-DZXING_BUILD_FOR_TEST>
)

if (WINRT)
    list (APPEND ZXING_PUBLIC_FLAGS
        -DWINRT
    )
endif()

if (MSVC)
    list (APPEND ZXING_PRIVATE_FLAGS
        -D_SCL_SECURE_NO_WARNINGS
        -D_CRT_SECURE_NO_WARNINGS
        -D_CRT_NONSTDC_NO_WARNINGS
        -DNOMINMAX
        /utf-8 # see https://github.com/zxing-cpp/zxing-cpp/issues/757
    )
else()
    list (APPEND ZXING_PRIVATE_FLAGS
        -Wall -Wextra -Wno-missing-braces -Werror=undef -Werror=return-type)
endif()

include (CheckCXXCompilerFlag)

# This is needed for reproducible builds across different build directories.
# Without this, the usage of the __FILE__ macro leaves the build directory in
# the binary. When building the Python extension with build isolation enabled
# this would lead to random paths in the binary.
set(FILE_PREFIX_ARG "-fmacro-prefix-map=${CMAKE_CURRENT_SOURCE_DIR}/=")
check_cxx_compiler_flag("${FILE_PREFIX_ARG}" HAS_FILE_PREFIX_ARG)
if(HAS_FILE_PREFIX_ARG)
    list (APPEND ZXING_PRIVATE_FLAGS "${FILE_PREFIX_ARG}")
endif()

################# Source files

set (COMMON_FILES
    src/Barcode.h
    src/Barcode.cpp
    src/BarcodeData.h
    src/BarcodeFormat.h
    src/BarcodeFormat.cpp
    src/BitMatrix.h
    src/BitMatrix.cpp
    src/BitMatrixIO.h
    src/BitMatrixIO.cpp
    src/ByteArray.h
    src/CharacterSet.h
    src/CharacterSet.cpp
    src/CreateBarcode.h
    src/CreateBarcode.cpp
    src/Content.h
    src/Content.cpp
    src/ContentType.h
    src/DecoderResult.h
    src/DetectorResult.h
    src/ECI.h
    src/ECI.cpp
    src/Error.h
    src/Error.cpp
    src/Flags.h
    src/GTIN.h
    src/GTIN.cpp
    src/ImageView.h
    src/JSON.h
    src/JSON.cpp
    src/Matrix.h
    src/Point.h
    src/Quadrilateral.h
    src/Range.h
    src/ReaderOptions.h
    src/ReadBarcode.h
    src/ReadBarcode.cpp
    src/SymbologyIdentifier.h
    src/Utf.h
    src/Utf.cpp
    src/WriteBarcode.h
    src/WriteBarcode.cpp
    src/ZXingCpp.h
    src/ZXingCpp.cpp
    src/ZXAlgorithms.h
    src/ZXConfig.h
    src/ZXTestSupport.h
    $<$<BOOL:${ZXING_C_API}>:src/ZXingC.h>
    $<$<BOOL:${ZXING_C_API}>:src/ZXingC.cpp>
)
if (ZXING_READERS OR ZXING_WRITERS_OLD)
    set (COMMON_FILES ${COMMON_FILES}
        src/BitArray.h
        src/BitArray.cpp
        src/GenericGF.h
        src/GenericGF.cpp
        src/GenericGFPoly.h
        src/GenericGFPoly.cpp
    )
endif()
if (ZXING_READERS OR ZXING_WRITERS_NEW)
    set (COMMON_FILES ${COMMON_FILES}
        src/HRI.h
        src/HRI.cpp
    )
endif()
if (ZXING_READERS)
    set (COMMON_FILES ${COMMON_FILES}
        src/BinaryBitmap.h
        src/BinaryBitmap.cpp
        src/BitMatrixCursor.h
        src/BitSource.h
        src/BitSource.cpp
        src/ConcentricFinder.h
        src/ConcentricFinder.cpp
        src/GlobalHistogramBinarizer.h
        src/GlobalHistogramBinarizer.cpp
        src/GridSampler.h
        src/GridSampler.cpp
        src/LogMatrix.h
        src/HybridBinarizer.h
        src/HybridBinarizer.cpp
        src/MultiFormatReader.h
        src/MultiFormatReader.cpp
        src/Pattern.h
        src/PerspectiveTransform.h
        src/PerspectiveTransform.cpp
        src/Reader.h
        src/ReedSolomonDecoder.h
        src/ReedSolomonDecoder.cpp
        src/RegressionLine.h
        src/ResultPoint.h
        src/ResultPoint.cpp
        src/StructuredAppend.h
        src/StdGenerator.h
        src/StdPrint.h
        src/StdScope.h
        src/TextDecoder.h
        src/TextDecoder.cpp
        src/ThresholdBinarizer.h
        src/TritMatrix.h # QRCode
        src/WhiteRectDetector.h
        src/WhiteRectDetector.cpp
    )
endif()

if (ZXING_WRITERS)
    set (COMMON_FILES ${COMMON_FILES}
        src/TextEncoder.h
        src/TextEncoder.cpp
    )
endif()

if (ZXING_WRITERS_OLD)
    set (COMMON_FILES ${COMMON_FILES}
        src/ReedSolomonEncoder.h
        src/ReedSolomonEncoder.cpp
        src/MultiFormatWriter.h
        src/MultiFormatWriter.cpp
    )
endif()

# define subset of public headers that get distributed with the binaries
set (PUBLIC_HEADERS
    src/Barcode.h
    src/BarcodeFormat.h
    src/CharacterSet.h
    src/ContentType.h
    src/CreateBarcode.h
    src/Error.h
    src/GTIN.h
    src/ImageView.h
    src/Point.h
    src/Quadrilateral.h
    src/ReadBarcode.h
    src/ReaderOptions.h
    src/WriteBarcode.h
    src/ZXingCpp.h
    $<$<BOOL:${ZXING_C_API}>:${CMAKE_CURRENT_SOURCE_DIR}/src/ZXingC.h>
)
if (ZXING_READERS)
    set (PUBLIC_HEADERS ${PUBLIC_HEADERS}
    )
endif()
if (ZXING_WRITERS_OLD)
    set (PUBLIC_HEADERS ${PUBLIC_HEADERS}
        src/BitMatrix.h
        src/BitMatrixIO.h
        src/Matrix.h
        src/MultiFormatWriter.h
    )
endif()
# end of public header set

if (ZXING_READERS AND ZXING_ENABLE_AZTEC)
    set (AZTEC_FILES ${AZTEC_FILES}
        src/aztec/AZDecoder.h
        src/aztec/AZDecoder.cpp
        src/aztec/AZDetector.h
        src/aztec/AZDetector.cpp
        src/aztec/AZDetectorResult.h
        src/aztec/AZReader.h
        src/aztec/AZReader.cpp
    )
endif()
if (ZXING_WRITERS_OLD AND ZXING_ENABLE_AZTEC)
    set (AZTEC_FILES ${AZTEC_FILES}
        src/aztec/AZEncodingState.h
        src/aztec/AZEncoder.h
        src/aztec/AZEncoder.cpp
        src/aztec/AZHighLevelEncoder.h
        src/aztec/AZHighLevelEncoder.cpp
        src/aztec/AZToken.h
        src/aztec/AZToken.cpp
        src/aztec/AZWriter.h
        src/aztec/AZWriter.cpp
    )
endif()


if ((ZXING_READERS OR ZXING_WRITERS_OLD) AND ZXING_ENABLE_DATAMATRIX)
    set (DATAMATRIX_FILES
        src/datamatrix/DMBitLayout.h
        src/datamatrix/DMBitLayout.cpp
        src/datamatrix/DMVersion.h
        src/datamatrix/DMVersion.cpp
    )
endif()
if (ZXING_READERS AND ZXING_ENABLE_DATAMATRIX)
    set (DATAMATRIX_FILES ${DATAMATRIX_FILES}
        src/datamatrix/DMDataBlock.h
        src/datamatrix/DMDataBlock.cpp
        src/datamatrix/DMDecoder.h
        src/datamatrix/DMDecoder.cpp
        src/datamatrix/DMDetector.h
        src/datamatrix/DMDetector.cpp
        src/datamatrix/DMReader.h
        src/datamatrix/DMReader.cpp
    )
endif()
if (ZXING_WRITERS_OLD AND ZXING_ENABLE_DATAMATRIX)
    set (DATAMATRIX_FILES ${DATAMATRIX_FILES}
        src/datamatrix/DMECEncoder.h
        src/datamatrix/DMECEncoder.cpp
        src/datamatrix/DMEncoderContext.h
        src/datamatrix/DMHighLevelEncoder.h
        src/datamatrix/DMHighLevelEncoder.cpp
        src/datamatrix/DMSymbolInfo.h
        src/datamatrix/DMSymbolInfo.cpp
        src/datamatrix/DMSymbolShape.h
        src/datamatrix/DMWriter.h
        src/datamatrix/DMWriter.cpp
    )
endif()


if (ZXING_READERS AND ZXING_ENABLE_MAXICODE)
    set (MAXICODE_FILES ${MAXICODE_FILES}
        src/maxicode/MCBitMatrixParser.h
        src/maxicode/MCBitMatrixParser.cpp
        src/maxicode/MCDecoder.h
        src/maxicode/MCDecoder.cpp
        src/maxicode/MCReader.h
        src/maxicode/MCReader.cpp
    )
endif()


if ((ZXING_READERS OR ZXING_WRITERS_OLD) AND ZXING_ENABLE_1D)
    set (ONED_FILES
        src/oned/ODUPCEANCommon.h
        src/oned/ODUPCEANCommon.cpp
        src/oned/ODCode93Patterns.h
        src/oned/ODCode128Patterns.h
        src/oned/ODCode128Patterns.cpp
    )
endif()
if (ZXING_READERS AND ZXING_ENABLE_1D)
    set (ONED_FILES ${ONED_FILES}
        src/oned/ODCodabarReader.h
        src/oned/ODCodabarReader.cpp
        src/oned/ODCode39Reader.h
        src/oned/ODCode39Reader.cpp
        src/oned/ODCode93Reader.h
        src/oned/ODCode93Reader.cpp
        src/oned/ODCode128Reader.h
        src/oned/ODCode128Reader.cpp
        src/oned/ODDataBarCommon.h
        src/oned/ODDataBarCommon.cpp
        src/oned/ODDataBarReader.h
        src/oned/ODDataBarReader.cpp
        src/oned/ODDataBarExpandedBitDecoder.h
        src/oned/ODDataBarExpandedBitDecoder.cpp
        src/oned/ODDataBarExpandedReader.h
        src/oned/ODDataBarExpandedReader.cpp
        src/oned/ODDataBarLimitedReader.h
        src/oned/ODDataBarLimitedReader.cpp
        src/oned/ODDXFilmEdgeReader.h
        src/oned/ODDXFilmEdgeReader.cpp
        src/oned/ODITFReader.h
        src/oned/ODITFReader.cpp
        src/oned/ODMultiUPCEANReader.h
        src/oned/ODMultiUPCEANReader.cpp
        src/oned/ODReader.h
        src/oned/ODReader.cpp
        src/oned/ODRowReader.h
    )
endif()
if (ZXING_WRITERS_OLD AND ZXING_ENABLE_1D)
    set (ONED_FILES ${ONED_FILES}
        src/oned/ODCodabarWriter.h
        src/oned/ODCodabarWriter.cpp
        src/oned/ODCode39Writer.h
        src/oned/ODCode39Writer.cpp
        src/oned/ODCode93Writer.h
        src/oned/ODCode93Writer.cpp
        src/oned/ODCode128Writer.h
        src/oned/ODCode128Writer.cpp
        src/oned/ODEAN8Writer.h
        src/oned/ODEAN8Writer.cpp
        src/oned/ODEAN13Writer.h
        src/oned/ODEAN13Writer.cpp
        src/oned/ODITFWriter.h
        src/oned/ODITFWriter.cpp
        src/oned/ODUPCEWriter.h
        src/oned/ODUPCEWriter.cpp
        src/oned/ODUPCAWriter.h
        src/oned/ODUPCAWriter.cpp
        src/oned/ODWriterHelper.h
        src/oned/ODWriterHelper.cpp
    )
endif()


if ((ZXING_READERS OR ZXING_WRITERS_OLD) AND ZXING_ENABLE_PDF417)
    set (PDF417_FILES
        src/pdf417/ZXBigInteger.h
        src/pdf417/ZXBigInteger.cpp
    )
endif()
if (ZXING_READERS AND ZXING_ENABLE_PDF417)
    set (PDF417_FILES ${PDF417_FILES}
        src/pdf417/PDFBarcodeMetadata.h
        src/pdf417/PDFBarcodeValue.h
        src/pdf417/PDFBarcodeValue.cpp
        src/pdf417/PDFBoundingBox.h
        src/pdf417/PDFBoundingBox.cpp
        src/pdf417/PDFCodeword.h
        src/pdf417/PDFCodewordDecoder.h
        src/pdf417/PDFCodewordDecoder.cpp
        src/pdf417/PDFCustomData.h
        src/pdf417/PDFDecoder.h
        src/pdf417/PDFDecoder.cpp
        src/pdf417/PDFDetectionResult.h
        src/pdf417/PDFDetectionResult.cpp
        src/pdf417/PDFDetectionResultColumn.h
        src/pdf417/PDFDetectionResultColumn.cpp
        src/pdf417/PDFDetector.h
        src/pdf417/PDFDetector.cpp
        src/pdf417/PDFModulusGF.h
        src/pdf417/PDFModulusGF.cpp
        src/pdf417/PDFModulusPoly.h
        src/pdf417/PDFModulusPoly.cpp
        src/pdf417/PDFReader.h
        src/pdf417/PDFReader.cpp
        src/pdf417/PDFScanningDecoder.h
        src/pdf417/PDFScanningDecoder.cpp
        src/pdf417/ZXNullable.h
    )
endif()
if (ZXING_WRITERS_OLD AND ZXING_ENABLE_PDF417)
    set (PDF417_FILES ${PDF417_FILES}
        src/pdf417/PDFCompaction.h
        src/pdf417/PDFEncoder.h
        src/pdf417/PDFEncoder.cpp
        src/pdf417/PDFHighLevelEncoder.h

=== test/install/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(ZXingInstallTest LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17) # make sure the public API is still c++17 compatible

find_package(ZXing CONFIG REQUIRED)

add_executable(InstallTest main.cpp)

target_link_libraries(InstallTest PRIVATE ZXing::ZXing)

=== wrappers/qt/CMakeLists.txt ===

find_package(Qt6 COMPONENTS Gui Multimedia Quick Widgets QUIET)
if (NOT (Qt5_FOUND OR Qt6_FOUND))
    message("INFO: Qt (Gui/Multimedia/Quick/Widgets) not found, skipping Qt examples")
endif()

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(ZXING_QT_DEFINITIONS
    QT_NO_KEYWORDS
    QT_NO_CAST_TO_ASCII
    QT_NO_CAST_FROM_ASCII
    QT_STRICT_ITERATORS
    QT_NO_URL_CAST_FROM_STRING
    QT_NO_CAST_FROM_BYTEARRAY
    QT_USE_QSTRINGBUILDER
    QT_NO_SIGNALS_SLOTS_KEYWORDS
    QT_USE_FAST_OPERATOR_PLUS
    QT_DISABLE_DEPRECATED_BEFORE=0x060400
)

if (ZXING_READERS)
    if (TARGET Qt::Gui)
        add_executable (ZXingQtReader ZXingQtReader.cpp ZXingQt.h)
        target_link_libraries(ZXingQtReader ZXing::ZXing Qt::Gui)
        target_compile_definitions(ZXingQtReader PRIVATE ${ZXING_QT_DEFINITIONS})
    endif()

    if (TARGET Qt::Multimedia AND TARGET Qt::Quick)
        add_executable(ZXingQmlReader ZXingQmlReader.cpp ZXingQmlReader.qrc ZXingQt.h)
        target_link_libraries(ZXingQmlReader PRIVATE ZXing::ZXing Qt::Gui Qt::Multimedia Qt::Quick)
        target_compile_definitions(ZXingQmlReader PRIVATE ${ZXING_QT_DEFINITIONS})
        if (APPLE)
            set_target_properties(ZXingQmlReader PROPERTIES
                MACOSX_BUNDLE TRUE
                MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/ZXingQmlReader-Info.plist
            )
        endif()
        qt_finalize_executable(ZXingQmlReader)
    endif()

    if (TARGET Qt::Multimedia AND TARGET Qt::Widgets)
        add_executable(ZXingQtCamReader ZXingQtCamReader.cpp ZXingQt.h)
        target_link_libraries(ZXingQtCamReader PRIVATE ZXing::ZXing Qt::Gui Qt::Multimedia Qt::Widgets)
        target_compile_definitions(ZXingQtCamReader PRIVATE ${ZXING_QT_DEFINITIONS})
        if (APPLE)
            set_target_properties(ZXingQtCamReader PROPERTIES
                MACOSX_BUNDLE TRUE
                MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/ZXingQtCamReader-Info.plist
            )
        endif()
        qt_finalize_executable(ZXingQtCamReader)
    endif()

endif()

if (ZXING_WRITERS)
    if (TARGET Qt::Gui)
        add_executable (ZXingQtWriter ZXingQtWriter.cpp)
        target_link_libraries(ZXingQtWriter ZXing::ZXing Qt::Gui)
        target_compile_definitions(ZXingQtWriter PRIVATE ${ZXING_QT_DEFINITIONS})
    endif()
endif()

=== debian/changelog ===
zxing-cpp (3.0.0~rc1+ds-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
    + Repack the tarball to include zint/2.16.0 source code as MUT
      component as suggested upstream.
  * debian/watch: Update to version 5 and add the zint component.
  * debian/copyright: Add information from zint component.
  * debian/: Bump library SONAME to 4.
  * debian/rules: Update build flags following upstream suggestion.
  * debian/control: Build-depends on system libpng-dev.

 -- Boyuan Yang <byang@debian.org>  Thu, 05 Feb 2026 14:45:34 -0500

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: zxing-cpp
 Section: libs
-Priority: optional
 Maintainer: Boyuan Yang <byang@debian.org>
 Build-Depends:
  cmake (>= 3.16),
@@ -10,15 +9,16 @@
  libgmock-dev <!nocheck>,
  libgtest-dev <!nocheck>,
  libpython3-dev,
+ libpng-dev,
  libstb-dev,
+# libzint-dev (>= 2.16),
  pkgconf,
  pybind11-dev,
  python3-dev:native,
  python3-numpy <!nocheck>,
  python3-opencv <!nocheck>,
  python3-pil <!nocheck>,
-Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: https://github.com/zxing-cpp/zxing-cpp
 Vcs-Git: https://salsa.debian.org/debian/zxing-cpp.git
 Vcs-Browser: https://salsa.debian.org/debian/zxing-cpp
@@ -37,7 +37,7 @@
 Multi-Arch: same
 Section: libdevel
 Depends:
- libzxing3 (= ${binary:Version}),
+ libzxing4 (= ${binary:Version}),
  ${misc:Depends},
 Replaces:
  libzxingcore-dev (<< 1.3.0~),
@@ -48,7 +48,7 @@
  .
  This package provides development files for zxing-cpp library.
 
-Package: libzxing3
+Package: libzxing4
 Architecture: any
 Multi-Arch: same
 Depends:

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1
#
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Try to export buildflags. No guarantee to be useful yet
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/buildflags.mk

# https://bugs.debian.org/1123686
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata__$(DEB_HOST_ARCH_OS)_$(DEB_HOST_MULTIARCH)
endif


%:
	dh $@ --with python3

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
TEST_FLAG := ON
else
TEST_FLAG := OFF
endif

# PYTHON_EXECUTABLE: force selection of default python version
#
# UNIT_TESTS: should only be used in debug builds, disable it
# following upstream recommendation.
#
# ZXING_WRITERS: old writer backend may be needed by system
# software (e.g., libreoffice).
#
override_dh_auto_configure:
	dh_auto_configure -- \
	        -DZXING_BLACKBOX_TESTS=$(TEST_FLAG)  \
	        -DZXING_UNIT_TESTS=OFF               \
	        -DZXING_PYTHON_MODULE=ON             \
	        -DZXING_C_API=ON                     \
	        -DZXING_WRITERS=BOTH                 \
	        -DZXING_USE_BUNDLED_ZINT=ON          \
	        -DZXING_DEPENDENCIES=LOCAL           \
	        -DPYTHON_EXECUTABLE:FILEPATH=$(shell command -v $$(py3versions -d))

override_dh_auto_test:
	# Exclude tests that needs samples directory
	dh_auto_test -- \
	        ARGS\+=-E \
	        ARGS\+=ReaderTest\\\|ZXingCTest \
	        $(NULL)

# For importing the new upstream release:
#
# uscan --verbose --force-download ; gbp import-orig --pristine-tar --uscan --component=zint

## zxing-cpp 3.0.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,8 @@
 option (ZXING_EXAMPLES "Build the example barcode reader/writer applications" ON)
 option (ZXING_BLACKBOX_TESTS "Build the black box reader/writer tests" OFF)
 option (ZXING_UNIT_TESTS "Build the unit tests (don't enable for production builds)" OFF)
-option (ZXING_INSTALL_TEST "Test if the installed/public API works" OFF)
+option (ZXING_TEST_DOTNET "Test if the .NET wrapper works" OFF)
+option (ZXING_TEST_INSTALL "Test if the installed/public API works" OFF)
 option (ZXING_PYTHON_MODULE "Build the python module" OFF)
 set    (ZXING_DEPENDENCIES "AUTO" CACHE STRING "Fetch from github or use locally installed (AUTO/GITHUB/LOCAL)")
 option (ZXING_CLANG_TIDY "Enable clang-tidy analysis" OFF)
@@ -70,13 +71,9 @@
 endif()
 
 # make installed binaries relocatable on macOS and Linux
+set(CMAKE_BUILD_RPATH_USE_ORIGIN ON)  # improve build reproducibility
 set(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
-if(APPLE)
-    set(CMAKE_MACOSX_RPATH ON) # make the binar
-    set(CMAKE_INSTALL_RPATH "@loader_path/../lib")
-elseif(UNIX)
-    set(CMAKE_INSTALL_RPATH "$ORIGIN/../lib")
-endif()
+set(CMAKE_INSTALL_RPATH "$<$<PLATFORM_ID:Darwin>:@loader_path/../lib>$<$<PLATFORM_ID:Linux>:$ORIGIN/../lib>")
 
 add_subdirectory (core)
 
@@ -94,7 +91,10 @@
 if (ZXING_UNIT_TESTS)
     add_subdirectory (test/unit)
 endif()
-if (ZXING_INSTALL_TEST)
+if (ZXING_TEST_DOTNET)
+    add_subdirectory (wrappers/dotnet)
+endif()
+if (ZXING_TEST_INSTALL)
     add_test(
         NAME InstallTest
         COMMAND

=== core/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.16)
 
 project (ZXing VERSION "3.0.0")
-set (ZXING_VERSION_SUFFIX "-rc1")
+set (ZXING_VERSION_SUFFIX "")
 set (ZXING_SONAME 4) # see https://github.com/zxing-cpp/zxing-cpp/issues/333
 
 option (ZXING_USE_BUNDLED_ZINT "Use the bundled libzint for barcode creation/writing" ON)
@@ -47,19 +47,13 @@
 
 set (ZXING_USE_ZINT ${ZXING_WRITERS_NEW}) # see Version.h.in
 
-set (ZXING_PUBLIC_FLAGS
-    $<$<CXX_COMPILER_ID:MSVC>:/Zc:__cplusplus>
-)
-
 set (ZXING_PRIVATE_FLAGS
     -DZXING_INTERNAL
     $<$<BOOL:${ZXING_UNIT_TESTS}>:-DZXING_BUILD_FOR_TEST>
 )
 
 if (WINRT)
-    list (APPEND ZXING_PUBLIC_FLAGS
-        -DWINRT
-    )
+    set (ZXING_PUBLIC_FLAGS -DWINRT )
 endif()
 
 if (MSVC)
@@ -133,6 +127,7 @@
     src/WriteBarcode.cpp
     src/ZXingCpp.h
     src/ZXingCpp.cpp
+    src/ZXingQt.h
     src/ZXAlgorithms.h
     src/ZXConfig.h
     src/ZXTestSupport.h
@@ -227,6 +222,7 @@
     src/ReaderOptions.h
     src/WriteBarcode.h
     src/ZXingCpp.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ZXingQt.h
     $<$<BOOL:${ZXING_C_API}>:${CMAKE_CURRENT_SOURCE_DIR}/src/ZXingC.h>
 )
 if (ZXING_READERS)
@@ -425,3 +421,5 @@
         src/pdf417/PDFEncoder.h
         src/pdf417/PDFEncoder.cpp
         src/pdf417/PDFHighLevelEncoder.h
+        src/pdf417/PDFHighLevelEncoder.cpp
+        src/pdf417/PDFWriter.h

=== wrappers/python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
project(ZXingPython)

# check if we are called from the top-level ZXing project
get_directory_property(hasParent PARENT_DIRECTORY)
if (NOT hasParent)
    set(CMAKE_CXX_STANDARD 20) # required here for the module itself

    option (BUILD_SHARED_LIBS "Link python module to shared lib" OFF)
    option (ZXING_READERS "Build with reader support (decoders)" ON)
    set    (ZXING_WRITERS "NEW" CACHE STRING "Build with old and/or new writer (encoder) backend (OFF/ON/OLD/NEW)")
    set    (ZXING_DEPENDENCIES "AUTO" CACHE STRING "Fetch from github or use locally installed (AUTO/GITHUB/LOCAL)")
    option (ZXING_EXPERIMENTAL_API "Build with experimental API" ON)

    set(CORE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/core)
    if(IS_SYMLINK ${CORE_PATH})
        # This is needed because otherwise GCC resolves the symlink which causes paths to randomly
        # be prefixed by /core or by /wrappers/python/core depending on include order.
        set(CORE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../../core)
    endif()

    if(EXISTS ${CORE_PATH})
        add_subdirectory(${CORE_PATH} ZXing EXCLUDE_FROM_ALL)
        include(${CMAKE_CURRENT_SOURCE_DIR}/zxing.cmake)
    else()
        message(FATAL_ERROR "Unable to locate zxing source code")
    endif()
endif()

find_package(Python 3.10 COMPONENTS Interpreter Development.Module REQUIRED) # see https://github.com/pybind/pybind11/issues/4785
#set(PYBIND11_FINDPYTHON ON) # see https://github.com/pybind/pybind11/issues/4785
zxing_add_package(pybind11 pybind11 https://github.com/pybind/pybind11.git v3.0.1)

# build the python module
pybind11_add_module(zxingcpp zxing.cpp)
target_link_libraries(zxingcpp PRIVATE ZXing::ZXing)

if (ZXING_READERS AND ZXING_WRITERS)
    add_test(NAME PythonTest COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/test.py -v)
    set_property(TEST PythonTest PROPERTY ENVIRONMENT PYTHONPATH=$<TARGET_FILE_DIR:zxingcpp>)
endif()

if (NOT DEFINED ZXING_PYTHON_INSTALL_BINDIR)
    set(ZXING_PYTHON_INSTALL_BINDIR "${CMAKE_INSTALL_BINDIR}")
endif()

if (NOT DEFINED ZXING_PYTHON_INSTALL_LIBDIR)
    set(ZXING_PYTHON_INSTALL_LIBDIR "${CMAKE_INSTALL_LIBDIR}")
endif()

install(TARGETS zxingcpp
    COMPONENT python
    RUNTIME DESTINATION "${ZXING_PYTHON_INSTALL_BINDIR}"
    LIBRARY DESTINATION "${ZXING_PYTHON_INSTALL_LIBDIR}"
    ARCHIVE DESTINATION "${ZXING_PYTHON_INSTALL_LIBDIR}")

=== debian/changelog ===
zxing-cpp (3.0.0+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/control: Drop unnecessary versioned dep.
  * debian/gbp.conf: Properly add zint component.

 -- Boyuan Yang <byang@debian.org>  Tue, 10 Feb 2026 13:33:28 -0500

zxing-cpp (3.0.0~rc1+ds-1~exp2) experimental; urgency=medium

  * debian/patches/backport/: Backport upstream trunk commits.
  * debian/control: Drop unnecessary (test-)build-dep libgtest-dev,
    libgmock-dev.
  * debian/control: Drop unnecessary build-dep libpng-dev, libfmt-dev.
  * debian/control: Add Qt6 build-deps to enable Qt6-based wrapper
    building.
  * debian/control: Update package description following upstream
    suggestion.

 -- Boyuan Yang <byang@debian.org>  Fri, 06 Feb 2026 09:41:27 -0500

=== debian/rules ===
--- 
+++ 
@@ -41,6 +41,7 @@
 	        -DZXING_PYTHON_MODULE=ON             \
 	        -DZXING_C_API=ON                     \
 	        -DZXING_WRITERS=BOTH                 \
+	        -DZXING_EXAMPLES=ON                  \
 	        -DZXING_USE_BUNDLED_ZINT=ON          \
 	        -DZXING_DEPENDENCIES=LOCAL           \
 	        -DPYTHON_EXECUTABLE:FILEPATH=$(shell command -v $$(py3versions -d))

## zxing-cpp 3.0.1%2Bds

=== core/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.16)
 
-project (ZXing VERSION "3.0.0")
+project (ZXing VERSION "3.0.1")
 set (ZXING_VERSION_SUFFIX "")
 set (ZXING_SONAME 4) # see https://github.com/zxing-cpp/zxing-cpp/issues/333
 
@@ -131,6 +131,7 @@
     src/ZXAlgorithms.h
     src/ZXConfig.h
     src/ZXTestSupport.h
+    src/ZXVersion.h
     $<$<BOOL:${ZXING_C_API}>:src/ZXingC.h>
     $<$<BOOL:${ZXING_C_API}>:src/ZXingC.cpp>
 )
@@ -222,6 +223,7 @@
     src/ReaderOptions.h
     src/WriteBarcode.h
     src/ZXingCpp.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ZXVersion.h # deprecated, but keep it for now to not break old clients
     ${CMAKE_CURRENT_SOURCE_DIR}/src/ZXingQt.h
     $<$<BOOL:${ZXING_C_API}>:${CMAKE_CURRENT_SOURCE_DIR}/src/ZXingC.h>
 )
@@ -419,7 +421,3 @@
     set (PDF417_FILES ${PDF417_FILES}
         src/pdf417/PDFCompaction.h
         src/pdf417/PDFEncoder.h
-        src/pdf417/PDFEncoder.cpp
-        src/pdf417/PDFHighLevelEncoder.h
-        src/pdf417/PDFHighLevelEncoder.cpp
-        src/pdf417/PDFWriter.h

=== wrappers/c/CMakeLists.txt ===
zxing_add_package_stb()

if (ZXING_READERS)
    add_executable (ZXingCTest ZXingCTest.c)
    target_link_libraries (ZXingCTest ZXing::ZXing stb::stb)
    add_test(NAME ZXingCTest COMMAND ZXingCTest ${CMAKE_SOURCE_DIR}/test/samples/qrcode-1/1.png QRCode)
endif()

## zxing-cpp 3.0.1+ds

=== test/fuzz/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.16)


set (CMAKE_CXX_COMPILER /usr/bin/clang++) # -fsanitize=fuzzer only available in clang

project (ZXingFuzz)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -march=native -fsanitize=address,undefined,fuzzer")

set (ZXING_WRITERS BOTH)
set (ZXING_READERS ON)

add_definitions (-DZXING_BUILD_FOR_TEST)
add_subdirectory (${CMAKE_CURRENT_SOURCE_DIR}/../../core ${CMAKE_BINARY_DIR}/ZXing)

set (TESTS
    DBEDecoder
    DMEncoder
    ReadLinear
    ReadMatrix
    DecodeMatrix
)

foreach (test ${TESTS})
    set (name "fuzz${test}")
    add_executable (${name} "${name}.cpp")
    target_link_libraries (${name} ZXing::ZXing)
endforeach()

=== debian/changelog ===
zxing-cpp (3.0.1+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/rules: Enable ZXING_EXAMPLE_QT build flag.

 -- Boyuan Yang <byang@debian.org>  Thu, 12 Feb 2026 11:03:36 -0500

zxing-cpp (3.0.0+ds-1~exp2) experimental; urgency=medium

  * debian/patches/backport/6c953c6f0b9893fdbec5e3f9d510b4e06ccd2265.patch:
    Add patch from upstream trunk on libreoffice compatibility fix.

 -- Boyuan Yang <byang@debian.org>  Tue, 10 Feb 2026 20:02:06 -0500

=== debian/watch ===
Version: 5

Template: GitHub
Owner: zxing-cpp
Project: zxing-cpp
Uversionmangle: s/-rc/~rc/
Repacksuffix: +ds
Dversion-Mangle: auto

Component: zint
Template: GitHub
Owner: zint
Project: zint
Version-Schema: ignore

## zxing-cpp 3.0.2%2Bds

=== core/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.16)
 
-project (ZXing VERSION "3.0.1")
+project (ZXing VERSION "3.0.2")
 set (ZXING_VERSION_SUFFIX "")
 set (ZXING_SONAME 4) # see https://github.com/zxing-cpp/zxing-cpp/issues/333
 
@@ -81,7 +81,7 @@
     list (APPEND ZXING_PRIVATE_FLAGS "${FILE_PREFIX_ARG}")
 endif()
 
-################# Source files
+# MARK: - COMMON_FILES
 
 set (COMMON_FILES
     src/Barcode.h
@@ -207,6 +207,8 @@
     )
 endif()
 
+# MARK: - PUBLIC_HEADERS
+
 # define subset of public headers that get distributed with the binaries
 set (PUBLIC_HEADERS
     src/Barcode.h
@@ -240,6 +242,8 @@
     )
 endif()
 # end of public header set
+
+# MARK: - READERS/WRITERS
 
 if (ZXING_READERS AND ZXING_ENABLE_AZTEC)
     set (AZTEC_FILES ${AZTEC_FILES}
@@ -420,4 +424,3 @@
 if (ZXING_WRITERS_OLD AND ZXING_ENABLE_PDF417)
     set (PDF417_FILES ${PDF417_FILES}
         src/pdf417/PDFCompaction.h
-        src/pdf417/PDFEncoder.h
